#include <iostream>
#include <fstream>
// Programa de multiplicacion de dos matrices  
using namespace std;
//dimensiones como variables globales
const int       n = 3, q = 2, m = 4, p = 3;

void 
matmult(float mat1[][n], float mat2[][q], float mat3[][q])
{
    //Comprobacion de compatibilidad de dimensiones
    if (n != p) {
        cout << " Dimensiones incorrectas. No se pueden multiplicar las matrices" << endl;
        exit(1);
    }
    //Multiplicacion de matrices
        for (int i = 0; i < m; i++)
        for (int j = 0; j < q; j++)
            mat3[i][j] = 0.;
    for (int i = 0; i < m; i++)
        for (int j = 0; j < q; j++)
            for (int k = 0; k < n; k++)
                mat3[i][j] += mat1[i][k] * mat2[k][j];
}

int 
main()
{
    //fichero de entrada
    ifstream fin("mat1.dat");
    //fichero de salida
        ofstream fout("matmultfun.dat");
    //definicion de dimensiones y matrices
        float           mat1[m][n], mat2[p][q], mat3[m][q];
    //lectura de dimensiones y elementos de matrices y posterior escritura
        // en pantalla
        for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            fin >> mat1[i][j];

    cout << "Primera Matriz" << endl;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++)
            cout << mat1[i][j] << "  ";
        cout << endl;
    }
    cout << endl;

    for (int i = 0; i < p; i++)
        for (int j = 0; j < q; j++)
            fin >> mat2[i][j];

    cout << "Segunda matriz" << endl;
    for (int i = 0; i < p; i++) {
        for (int j = 0; j < q; j++)
            cout << mat2[i][j] << "  ";
        cout << endl;
    }
    cout << endl;
    //Llamada a la funcion de multiplicacion
        matmult(mat1, mat2, mat3);
    //Impresion del resultado en pantalla y fichero
        cout << "Matriz producto" << endl;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < q; j++)
            cout << mat3[i][j] << "   ";
        cout << endl;
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < q; j++)
            fout << mat3[i][j] << "   ";
        fout << endl;
    }
    //cierre de las unidades de entrada y salida
        fin.close();
    fout.close();
    return 0;
}
